"use strict";
// https://facebook.github.io/react/blog/2015/12/16/ismounted-antipattern.html
Object.defineProperty(exports, "__esModule", { value: true });
function makeCancelable(promise) {
    var hasCanceled = false;
    var cancelablePromise = new Promise(function (resolve, reject) {
        promise.then(function (val) { return (hasCanceled ? reject({ isCanceled: true }) : resolve(val)); }, function (error) { return (hasCanceled ? reject({ isCanceled: true }) : reject(error)); });
    });
    cancelablePromise.cancel = function () {
        hasCanceled = true;
    };
    return cancelablePromise;
}
exports.default = makeCancelable;
