"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Status;
(function (Status) {
    Status["PRESENTING"] = "PRESENTING";
    Status["EDITING"] = "EDITING";
    Status["COMMITTING"] = "COMMITTING";
})(Status = exports.Status || (exports.Status = {}));
var Action;
(function (Action) {
    Action["CANCEL"] = "CANCEL";
    Action["CHANGE"] = "CHANGE";
    Action["COMMIT"] = "COMMIT";
    Action["FAIL"] = "FAIL";
    Action["START"] = "START";
    Action["SUCCESS"] = "SUCCESS";
})(Action = exports.Action || (exports.Action = {}));
function edit(value) {
    return {
        status: Status.EDITING,
        value: value
    };
}
function reset() {
    return {
        status: Status.PRESENTING,
        value: undefined
    };
}
exports.transitions = {
    PRESENTING: {
        START: edit,
        CHANGE: edit,
        COMMIT: function (value) { return ({
            status: Status.COMMITTING,
            value: value
        }); }
    },
    EDITING: {
        CANCEL: reset,
        CHANGE: edit,
        COMMIT: function () { return ({
            status: Status.COMMITTING
        }); }
    },
    COMMITTING: {
        FAIL: function () { return ({ status: Status.EDITING }); },
        SUCCESS: reset
    }
};
function transition(status, action, value) {
    return exports.transitions[status][action]
        ? exports.transitions[status][action](value)
        : { status: status };
}
exports.default = transition;
