"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var hoist_non_react_statics_1 = __importDefault(require("hoist-non-react-statics"));
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importDefault(require("react"));
var editable_1 = __importDefault(require("./editable"));
var omit_1 = __importDefault(require("./omit"));
function withEditable(Component) {
    var ComponentWithEditable = function (_a) {
        var onCancel = _a.onCancel, onCommit = _a.onCommit, value = _a.value, passthroughProps = __rest(_a, ["onCancel", "onCommit", "value"]);
        return (react_1.default.createElement(editable_1.default, { onCancel: onCancel, onCommit: onCommit, value: value }, function (editableProps) { return (react_1.default.createElement(Component, __assign({}, passthroughProps, editableProps))); }));
    };
    ComponentWithEditable.displayName = "WithEditable(" + (Component.displayName ||
        Component.name ||
        "Component") + ")";
    ComponentWithEditable.propTypes = __assign({ onCancel: prop_types_1.default.func, onCommit: prop_types_1.default.func, value: prop_types_1.default.any }, omit_1.default(Component.propTypes, [
        "onChange",
        "onCancel",
        "onCommit",
        "value",
        "status"
    ]));
    hoist_non_react_statics_1.default(ComponentWithEditable, Component);
    return ComponentWithEditable;
}
exports.default = withEditable;
